from os.path import isfile, join
import re
from UtilsRPE.Functions import type_of_contents, load_vault, listdir_ord


def line_is_declaration(_line):
    _line = _line.strip()
    if not _line:
        return False
    first_character = _line[0]
    if first_character in ["!", "&"]:
        return False
    if _line.count("!"):
        _line = _line[:_line.find("!")]
    if _line.count("="):
        return True
    return False


def line_is_real_declaration(_line):
    if _line.count("!"):
        _line = _line[:_line.find("!")]
    value = _line.split("=")[1]
    if value.count(","):
        return False
    if value.count("'"):
        return False
    if not value.count("."):
        return False
    try:
        float(value)
        return True
    except ValueError:
        return False


def add_val_to_variable(_line):
    eq_index = _line.find("=")
    first_section = _line[:eq_index]
    second_section = _line[eq_index:]
    return "   %s%sval\t" % (first_section.strip(), "%") + second_section


vault = load_vault()


# Script to add %val to real arguments in the namelists:
namelists_folder = "./ParameterNamelists"
path_to_namelists = join(namelists_folder, "Original")
path_to_modified_namelists = join(namelists_folder, "Modified")

all_namelists = [f for f in listdir_ord(path_to_namelists) if isfile(join(path_to_namelists, f))]

print(all_namelists)
pattern = "^([^\!]*)=([^\!]*)"

for namelist in all_namelists:
    path_to_file = join(path_to_namelists, namelist)
    print(path_to_file)
    with open(path_to_file) as f:
        data = [line for line in f]
        for index, _l in enumerate(data):
            if line_is_declaration(_l):
                m = re.search(pattern, _l)
                var, value = m.groups()
                type_of_var = type_of_contents(var, routine=None, vault=vault)
                if type_of_var == "rpe_var":
                    var = "%s%%val" % var.strip()
                    data[index] = "%s = %s\n" % (var, value)
                if type_of_var == "fld_n":
                    split_value = value.split(",")
                    value = value.replace(split_value[1], "-1, " + split_value[1])
                    data[index] = "%s = %s" % (var, value)

        text = "".join(data)
    path_to_file = join(path_to_modified_namelists, namelist)
    with open(path_to_file, "w") as f:
        f.write(text)


