def get_filename():
   from optparse import OptionParser
   from os import path

   print_file = False
   parser = OptionParser()
   parser.add_option("-f", "--file",
                  action="store_true", dest="print_file", default=False,
                  help="print filename before accuracy")
   (options, args) = parser.parse_args()
   _filenames = args
   print_file = options.print_file
   for _filename in _filenames:
       assert path.isfile(_filename),  "%s is not a valid file" % _filename
   return print_file, _filenames

def load_var(_filename,_var_name):
   import numpy as np
   from netCDF4 import Dataset as NetCDFFile
   nc = NetCDFFile(_filename)
   # Load longitudes, latitudes and bathymetry data
   # longitudes = nc.variables['nav_lon'][:]
   # latitudes = nc.variables['nav_lat'][:]
   _data = nc.variables[_var_name]
   _data = np.array(_data)
   # To solve problem with _FillValue
   _data[_data == 1e20] = 0
   return _data


def create_4d_file(data,var_name):
   from netCDF4 import Dataset as NetCDFFile
   # Open a new file
   filename = "output4d_"+var_name+".nc"
   output_ncdf = NetCDFFile(filename, 'w', format='NETCDF4')
   
   # Create the dimensions
   t,z,x,y = data.shape 
   output_ncdf.createDimension('x', x)
   output_ncdf.createDimension('y', y)
   output_ncdf.createDimension('z', z)
   output_ncdf.createDimension('t', t)
  
       # Create average and standard deviation variables.
   out_var = output_ncdf.createVariable(var_name, 'f4', ('t', 'z', 'x', 'y'))
   out_var[:, :, :, :] = data
   output_ncdf.close()

def create_3d_file(data,var_name):
   from netCDF4 import Dataset as NetCDFFile
   # Open a new file
   filename = "output3d_"+var_name+".nc"
   output_ncdf = NetCDFFile(filename, 'w', format='NETCDF4')
   
   # Create the dimensions
   t,x,y = data.shape 
   output_ncdf.createDimension('x', x)
   output_ncdf.createDimension('y', y)
   output_ncdf.createDimension('t', t)
  
       # Create average and standard deviation variables.
   out_var = output_ncdf.createVariable(var_name, 'f4', ('t', 'x', 'y'))
   out_var[:, :, :] = data
   output_ncdf.close()  
