from os import listdir
from os.path import isfile, isdir, join, dirname
import numpy as np
from netCDF4 import Dataset as NetCDFFile
import copy
import re
from sys import argv


def name_contains_any_word(name, words):
    # Function that returns True if name contains words, or if words is empty
    if words:
        for word in words:
            if name.count(name):
                return True
    else:
        # in case words is empty, return True
        return True
    return False


def sort_heuristic(string):
   pattern = "([a-z])([0-9]+)"
   m = re.search(pattern, string)
   letter = m.group(1)
   number = int(m.group(2))
   value = ord(letter)*1000+number
   return value

# Path to the folder containing the experiments
# path = "/gpfs/scratch/pr1egi00/pr1egi23/a1bo/19900101"

# JOB ID of the reference experiment corresponding a full double precision simulation
# reference_experiment = "REFERENCE_RUN"
# Path to the reference experiment folder
# reference_experiment_path = join(path, "%s" % reference_experiment)

# Load reference experiment data
path_to_mod = "%FILENAME1%"
try:
   nc = NetCDFFile(path_to_mod)
except OSError:
   print("File not found!: %s" % path_to_mod)
   exit(1)

TL = np.array(nc.variables["TLcost_function"])
BF = np.array(nc.variables["back_function"])
# Total cost function is the sum of TLcost and backfunction
reference_cost_function = TL + BF


# Path to mod output and precision file
# path_to_mod = argv[1]
path_to_mod = "%FILENAME2%"
# If both files exist, proceed
if isfile(path_to_mod):
    nc = NetCDFFile(path_to_mod)
    TL = np.array(nc.variables["TLcost_function"])
    BF = np.array(nc.variables["back_function"])
    s = TL + BF

    if len(s) == len(reference_cost_function):
        error = abs((s - reference_cost_function)[-1])
        print("error %.2e" % error)
    else:
        print("error 1000!")
        error = 1000
    # path_to_accuracy_file = join(dirname(path_to_mod), "accuracy.txt")
    # with open(path_to_accuracy_file, "w") as accuracy_file:
    #     accuracy_file.write("%.2e" % error)
else:
    raise IOError("File %s not found" % path_to_mod)