import re
import pickle as pkl


def process_line(line):
    pattern = "Var: *([0-9]+) ([FT])"
    m = re.match(pattern, line)
    var_id = int(m.group(1))
    used = m.group(2)

    if used == "T":
        used = True
    elif used == "F":
        used = False
    else:
        raise AssertionError("WTF?")
    return var_id, used


results = {}

with open("coverage_result.txt", "r") as f:
    for l in f:
        var_id, used = process_line(l)
        results[var_id] = used


var_ids = results.keys()
used_array = list(results.values())


used_vars = [v for v in var_ids if results[v]]


output_file = open("initial_set_of_used_variables.pkl", "wb")

pkl.dump(used_vars, output_file)

output_file.close()
